<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



$conf = array();
include("/etc/lms/lms-subsys-stats-gen.conf");

if (!$config['stats_gen_enable'])
	exit();

$macros = array();
$macros['graph_base'] = " -h ".$conf['graph_sizey']." -w ".$conf['graph_sizex'].". -a PNG";

define(DATA_DIR, "/var/lib/lms-subsys-stats-gen/");
$conf['base_rrd_dir'] = $conf['base_rrd_dir']."/";
$conf['remote_dir'] = $conf['remote_dir']."/";

$durations = array("quarterday", "week", "month", "year");

function get_params($duration)
{
	switch($duration)
	{
	 case "quarterday":
		$time="-21600";
		$title="'Last quarter-day'";
		break;
	 case "week":
		$time="-604800";
		$title="'Last week'";
		break;
	 case "month":
		$time="-1874880";
		$title="'Last month'";
		break;
	 case "year":
		$time="-22498560";
		$title="'Last year'";
		break;
	}

	return(array($time, $title));
}

function graph_cpu($rrd_dir, $host, $i)
{
	global		$durations, $macros;

	foreach($durations as $duration)
	{
		list($time, $title) = get_params($duration);
			
		$file = $rrd_dir."cpu".$i.".rrd";
		$file2 = DATA_DIR.$host."/cpu".$i."_".$duration.".png";
		
		$exec = "rrdtool graph ".$file2." --start ".$time." --end -60";
		$exec.=$macros['graph_base']." --title=\"CPU".$i." - ".$title."\" -v '%' -l 0 -u 100 -r";
		$exec.=" DEF:user0=".$file.":user:AVERAGE DEF:system0=".$file.":system:AVERAGE DEF:nice0=".$file.":nice:AVERAGE DEF:idle0=".$file.":idle:AVERAGE";
		$exec.=" CDEF:t0=user0,system0,nice0,idle0,+,+,+ CDEF:u0=100,user0,t0,/,* CDEF:s0=100,system0,t0,/,* CDEF:n0=100,nice0,t0,/,* CDEF:i0=100,idle0,t0,/,*";
		$exec.=" COMMENT:'Type         Max     Min   Average   Type        Max     Min   Average\\n'";
		$exec.=" AREA:u0#00ff00:'User  ' GPRINT:u0:MAX:'%6.2lf' GPRINT:u0:MIN:'%6.2lf' GPRINT:u0:AVERAGE:'%6.2lf  '";
		$exec.=" STACK:s0#ff0000:'System' GPRINT:s0:MAX:'%6.2lf' GPRINT:s0:MIN:'%6.2lf' GPRINT:s0:AVERAGE:'%6.2lf\\n'";
		$exec.=" STACK:n0#660066:'Nice  ' GPRINT:n0:MAX:'%6.2lf' GPRINT:n0:MIN:'%6.2lf' GPRINT:n0:AVERAGE:'%6.2lf  '";
		$exec.=" STACK:i0#0000ff:'Idle  ' GPRINT:i0:MAX:'%6.2lf' GPRINT:i0:MIN:'%6.2lf' GPRINT:i0:AVERAGE:'%6.2lf'";
		$exec.=" COMMENT:'\\n' COMMENT:\"Created: `date`\"";
		$exec.=" >/dev/null";

		shell_exec($exec);
	}
}

function graph_mem($rrd_dir, $host)
{
	global		$durations, $macros;

	foreach($durations as $duration)
	{
		list($time, $title) = get_params($duration);
			
		$file = $rrd_dir."mem.rrd";
		$file2 = DATA_DIR.$host."/mem_".$duration.".png";
		
		$exec = "rrdtool graph ".$file2." --start ".$time." --end -60";
		$exec.=$macros['graph_base']." --title=\"MEM - ".$title."\" -v '%' -l 0 -u 100 -r";
		$exec.=" DEF:mtotal=".$file.":mtotal:AVERAGE DEF:mused=".$file.":mused:AVERAGE DEF:stotal=".$file.":stotal:AVERAGE DEF:sused=".$file.":sused:AVERAGE";
		$exec.=" CDEF:mmed=mused,100,*,mtotal,/ CDEF:smed=sused,100,*,stotal,/";
		$exec.=" COMMENT:'Type         Max     Min   Average   Type        Max     Min   Average\\n'";
		$exec.=" LINE2:mmed#00ff00:'Memory' GPRINT:mmed:MAX:'%6.2lf' GPRINT:mmed:MIN:'%6.2lf' GPRINT:mmed:AVERAGE:'%6.2lf  '";
		$exec.=" LINE2:smed#0000ff:'Swap  ' GPRINT:smed:MAX:'%6.2lf' GPRINT:smed:MIN:'%6.2lf' GPRINT:smed:AVERAGE:'%6.2lf\\n'";
		$exec.=" COMMENT:'\\n' COMMENT:\"Created: `date`\"";
		$exec.=" >/dev/null";

		shell_exec($exec);
	}
}

function graph_load($rrd_dir, $host)
{
	global		$durations, $macros;

	foreach($durations as $duration)
	{
		list($time, $title) = get_params($duration);
			
		$file = $rrd_dir."load.rrd";
		$file2 = DATA_DIR.$host."/load_".$duration.".png";
		
		$exec = "rrdtool graph ".$file2." --start ".$time." --end -60";
		$exec.=$macros['graph_base']." --title=\"LOAD - ".$title."\" -v 'Nb Process' -l 0 -u 1 --units-exponent 0";
		$exec.=" DEF:load=".$file.":load:AVERAGE";
		$exec.=" COMMENT:'Type         Max     Min   Average\\n'";
		$exec.=" AREA:load#0000ff:'Load  ' GPRINT:load:MAX:'%6.2lf' GPRINT:load:MIN:'%6.2lf' GPRINT:load:AVERAGE:'%6.2lf  '";
		$exec.=" COMMENT:'\\n' COMMENT:\"Created: `date`\"";
		$exec.=" >/dev/null";

		shell_exec($exec);
	}
}

function graph_net_eth($rrd_dir, $host, $i)
{
	global		$durations, $macros, $params;

	$file = $rrd_dir."net_eth".$i.".rrd";

	foreach($durations as $duration)
	{
		list($time, $title) = get_params($duration);
			
		$file2 = DATA_DIR.$host."/net_eth".$i."_".$duration.".png";
		
		$exec = "rrdtool graph ".$file2." --start ".$time." --end -60";
		$exec.=$macros['graph_base']." --title=\"NET eth".$i." (".$params['net_ip']['eth'.$i].") - ".$title."\" -v 'byte/s' -l 0 -u ".max($params['net_bp']['eth'.$i.'_in'], $params['net_bp']['eth'.$i.'_out'])." -r";
		$exec.=" DEF:input=".$file.":input:MAX DEF:output=".$file.":output:MAX";
		$exec.=" COMMENT:'Trafic     Max     Min     Average\\n'";
		$exec.=" AREA:input#00ff00:'D/L' GPRINT:input:MAX:'%6.2lf' GPRINT:input:MIN:'%6.2lf' GPRINT:input:AVERAGE:'%6.2lf\\n'";
		$exec.=" LINE1:output#0000ff:'U/L' GPRINT:output:MAX:'%6.2lf' GPRINT:output:MIN:'%6.2lf' GPRINT:output:AVERAGE:'%6.2lf'";
		$exec.=" HRULE:".$params['net_bp']['eth'.$i.'_in']."#ff0000 HRULE:".$params['net_bp']['eth'.$i.'_out']."#ff3300";
		$exec.=" COMMENT:'\\n' COMMENT:\"Created: `date`\"";
		$exec.=" >/dev/null";

		shell_exec($exec);
		
		$file2 = DATA_DIR.$host."/net_eth".$i."_errors_".$duration.".png";
		
		$exec = "rrdtool graph ".$file2." --start ".$time." --end -60";
		$exec.=$macros['graph_base']." --title=\"NET eth".$i." (".$params['net_ip']['eth'.$i].") errors - ".$title."\" -v 'packets' -l 0";
		$exec.=" DEF:ierror=".$file.":ierror:MAX DEF:oerror=".$file.":oerror:MAX DEF:collision=".$file.":collision:MAX";
		$exec.=" COMMENT:'Dir.        Max     Min   Average   Dir.        Max     Min   Average\\n'";
		$exec.=" LINE1:ierror#00ff00:'D/L  ' GPRINT:ierror:MAX:'%6.2lf' GPRINT:ierror:MIN:'%6.2lf' GPRINT:ierror:AVERAGE:'%6.2lf  '";
		$exec.=" LINE1:oerror#0000ff:'U/L  ' GPRINT:oerror:MAX:'%6.2lf' GPRINT:oerror:MIN:'%6.2lf' GPRINT:oerror:AVERAGE:'%6.2lf\\n'";
		$exec.=" LINE1:oerror#ff0000:'Coll.' GPRINT:collision:MAX:'%6.2lf' GPRINT:collision:MIN:'%6.2lf' GPRINT:collision:AVERAGE:'%6.2lf'";
		$exec.=" COMMENT:'\\n' COMMENT:\"Created: `date`\"";
		$exec.=" >/dev/null";

		shell_exec($exec);
	}
}

function graph_disk($rrd_dir, $host)
{
	global		$durations, $macros;

	foreach($durations as $duration)
	{
		list($time, $title) = get_params($duration);
			
		$file = $rrd_dir."disk.rrd";
		$file2 = DATA_DIR.$host."/disk_".$duration.".png";
		
		$exec = "rrdtool graph ".$file2." --start ".$time." --end -60";
		$exec.=$macros['graph_base']." --title=\"DISK - ".$title."\" -v 'Nb I/O operations' -l 0";
		$exec.=" DEF:disk=".$file.":disk:MAX";
		$exec.=" COMMENT:'Type         Max      Min     Average\\n'";
		$exec.=" AREA:disk#bb00ff:'Disk  ' GPRINT:disk:MAX:'%6.2lf' GPRINT:disk:MIN:'%6.2lf' GPRINT:disk:AVERAGE:'%6.2lf  '";
		$exec.=" COMMENT:'\\n' COMMENT:\"Created: `date`\"";
		$exec.=" >/dev/null";

		shell_exec($exec);
	}
}

function store_graphs()
{
	global		$conf;

	switch($conf['store_method'])
	{
	case "none":
		break;
	case "cp":
		shell_exec("cp -r ".DATA_DIR."* ".$conf['remote_dir']);
		break;
	}
}



if ($dh = opendir($conf['base_rrd_dir']))
{
	while (($host = readdir($dh)) !== false)
	{
		if (substr($host, 0, 1) == ".")
			continue;

		if (!file_exists(DATA_DIR.$host))
			mkdir(DATA_DIR.$host, 0700);

		$rrd_dir = $conf['base_rrd_dir'].$host."/";
		if (is_dir($rrd_dir))
		{
			$fd = fopen($rrd_dir."params.conf", "r");
			$data = fread($fd, filesize($rrd_dir."params.conf"));
			$params = unserialize(stripslashes($data));
			fclose($fd);

			// CPU
			$i = 0;
			while (file_exists($rrd_dir."cpu".$i.".rrd"))
			{
				graph_cpu($rrd_dir, $host, $i);
				$i++;
			}

			// Mem
			if (file_exists($rrd_dir."mem.rrd"))
				graph_mem($rrd_dir, $host);

			// Load
			if (file_exists($rrd_dir."load.rrd"))
				graph_load($rrd_dir, $host);

			// NET
			$i = 0;
			while (file_exists($rrd_dir."net_eth".$i.".rrd"))
			{
				graph_net_eth($rrd_dir, $host, $i);
				$i++;
			}

			// Disk
			if (file_exists($rrd_dir."disk.rrd"))
				graph_disk($rrd_dir, $host);
		}
	}
	closedir ($dh);
}

store_graphs();

?>
